- name: Debug Meta
  debug: var=ansible_operator_meta
- name: Debug Toggles
  debug:
    msg: |
      affinities:{{ do_affinities }},
      backups:{{ do_backups }},
      debugs:{{ do_debugs }},
      exporters:{{ do_exporters }},
      hpa:{{ do_hpa }},
      imagesfrom:{{ opsperator_images_registry }},
      memcached:{{ do_memcached }},
      networkpolicy:{{ do_network_policy }},
      triggers:{{ do_triggers }}
  failed_when: False
- name: Sets Objects Names according to input metadata
  set_fact:
    cr_apivers: wopla.io/v1beta1
    cr_kind: ZPush
    cr_name: "{{ ansible_operator_meta.name }}"
    memcached_name: "zpush-memcached-{{ ansible_operator_meta.name }}"
    namespace: "{{ ansible_operator_meta.namespace }}"
    pki_set: []
    zpshms_name: "zpush-mariadb-{{ ansible_operator_meta.name }}"
    zpshpc_name: "zpush-percona-{{ ansible_operator_meta.name }}"
    zpshpg_name: "zpush-postgres-{{ ansible_operator_meta.name }}"
    zpush_name: "zpush-{{ ansible_operator_meta.name }}"
- include_role:
    name: commons
    tasks_from: helpers/get-lock.yaml
- name: "Checks {{ cr_name }} CR Status"
  async: 30
  changed_when: False
  k8s_info:
    api_version: "{{ cr_apivers }}"
    kind: "{{ cr_kind }}"
    name: "{{ cr_name }}"
    namespace: "{{ namespace }}"
  no_log: True
  poll: 5
  register: zpush_crd
- name: Exits if CR is paused
  meta: end_play
  when:
  - zpush_crd is defined
  - zpush_crd.resources | length > 0
  - zpush_crd.resources[0].spec is defined
  - zpush_crd.resources[0].spec.pause | default(False)
- include_role:
    name: commons
    tasks_from: helpers/k8s-flavor.yaml
- include_role:
    name: commons
    tasks_from: helpers/sc-check.yaml
  vars:
    requires_rwo: True
- name: Forces Using MariaDB when Percona requested on ARM
  set_fact:
    zpush_db_type: mysql
  when:
  - k8s_flavor == 'kubernetes'
  - zpush_db_type == 'percona'
  - do_arm64 or do_arm
  - not do_amd64
- name: Fail if Database Type is not Supported
  fail:
    msg:
      CRITICAL - unsupported {{ zpush_db_type }} database driver
      pick one from mysql, percona, postgres, file
  when:
  - zpush_db_type not in [ 'mariadb', 'mysql', 'percona', 'postgres', 'file' ]
- name: Forces Replicas count on Non-scalable Deployments
  set_fact:
    zpush_max_replicas: 1
    zpush_min_replicas: 1
    zpush_replicas: 1
  when:
  - >
      (rwx_storage is not defined
       and zpush_db_type == 'file')
      or not do_memcached
